=== modified file 'NEWS'
--- NEWS	2007-09-17 12:46:56 +0000
+++ NEWS	2007-09-17 19:16:10 +0000
@@ -41,6 +41,10 @@
      longer throws away the profiling data if this command is run with
      ``--lsprof-file callgrind.out.ci`` say. (Ian Clatworthy)
 
+   * HttpServer and FtpServer need to be closed properly or a listening socket
+     will remain opened.
+     (Vincent Ladeuil, #140055)
+
   API BREAKS:
 
    * The ``VersionedFile`` interface now allows content checks to be bypassed

=== modified file 'bzrlib/tests/HttpServer.py'
--- bzrlib/tests/HttpServer.py	2007-04-21 21:31:32 +0000
+++ bzrlib/tests/HttpServer.py	2007-09-17 15:48:23 +0000
@@ -380,6 +380,7 @@
 
     def tearDown(self):
         """See bzrlib.transport.Server.tearDown."""
+        self._httpd.server_close()
         self._http_running = False
         self._http_thread.join()
 

=== modified file 'bzrlib/transport/ftp.py'
--- bzrlib/transport/ftp.py	2007-09-05 13:38:20 +0000
+++ bzrlib/transport/ftp.py	2007-09-17 18:16:01 +0000
@@ -586,8 +586,7 @@
 
     def tearDown(self):
         """See bzrlib.transport.Server.tearDown."""
-        # have asyncore release the channel
-        self._ftp_server.del_channel()
+        self._ftp_server.close()
         asyncore.close_all()
         self._async_thread.join()
 

